CREATE OR REPLACE TRIGGER DTULTATU_FILITABGER
BEFORE INSERT OR UPDATE OR DELETE
ON FILITABGER FOR EACH ROW
DECLARE
   V_CDTABEPREC VARCHAR2(03);
   V_CDFILIAL VARCHAR2(04);
   V_COUNT NUMBER;
   V_DSCHAVE VARCHAR2(100);
BEGIN
   IF INSERTING OR UPDATING THEN
      :NEW.DTULTATU := SYSDATE;
      V_CDTABEPREC := NVL(:NEW.CDTABEPREC, :OLD.CDTABEPREC);
      V_CDFILIAL := NVL(:NEW.CDFILIAL, :OLD.CDFILIAL);
      V_DSCHAVE := V_CDTABEPREC||'|'||V_CDFILIAL;
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM CTRLATUALTAB
          WHERE NMTABELA = 'FILITABGER'
            AND DSCHAVE = V_DSCHAVE;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         INSERT INTO CTRLATUALTAB
            (NMTABELA, DSCHAVE, DTULTATU)
         VALUES
            ('FILITABGER', V_DSCHAVE, SYSDATE);
      ELSE
         UPDATE CTRLATUALTAB
            SET DTULTATU = SYSDATE
          WHERE NMTABELA = 'FILITABGER'
            AND DSCHAVE = V_DSCHAVE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FILITABGER', :OLD.CDFILIAL, 'CDTABEPREC='||:OLD.CDTABEPREC||';CDFILIAL='||:OLD.CDFILIAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FILITABGER MODIFY DTULTATU DEFAULT SYSDATE
/

CREATE INDEX TABEPRECGER_01 ON TABEPRECGER (CDTABEPREC)
/

CREATE INDEX TABEVENDGER_01 ON TABEVENDGER (CDTABEPREC)
/

CREATE INDEX ITEMPRECOGER_01 ON ITEMPRECOGER (CDTABEPREC)
/

CREATE INDEX ITEMPRECODIAGER_01 ON ITEMPRECODIAGER (CDTABEPREC)
/